Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1959)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1960)
@@ -19,5 +19,8 @@
 ! Current revisions:
 ! ------------------
-! 
+! Separate humidity and passive scalar
+! Increase dimension for mean_inflow_profiles
+! Remove inadvertent write-statement
+! Bugfix, large-scale forcing is still not implemented for passive scalars
 !
 ! Former revisions:
@@ -469,7 +472,7 @@
     ENDIF
 
-    IF ( humidity  .OR.  passive_scalar )  THEN
-!
-!--    2D-humidity/scalar arrays
+    IF ( humidity )  THEN
+!
+!--    2D-humidity
        ALLOCATE ( qs(nysg:nyng,nxlg:nxrg),                                     &
                   qsws(nysg:nyng,nxlg:nxrg),                                   &
@@ -477,5 +480,5 @@
 
 !
-!--    3D-humidity/scalar arrays
+!--    3D-humidity
 #if defined( __nopointer )
        ALLOCATE( q(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
@@ -489,5 +492,5 @@
 
 !
-!--    3D-arrays needed for humidity only
+!--    3D-arrays needed for humidity
        IF ( humidity )  THEN
 #if defined( __nopointer )
@@ -570,4 +573,25 @@
        ENDIF
 
+    ENDIF
+    
+    
+    IF ( passive_scalar )  THEN
+!
+!--    2D-scalar arrays
+       ALLOCATE ( ss(nysg:nyng,nxlg:nxrg),                                     &
+                  ssws(nysg:nyng,nxlg:nxrg),                                   &
+                  sswst(nysg:nyng,nxlg:nxrg) )
+
+!
+!--    3D scalar arrays
+#if defined( __nopointer )
+       ALLOCATE( s(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
+                 s_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                           &
+                 ts_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+#else
+       ALLOCATE( s_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                           &
+                 s_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                           &
+                 s_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+#endif
     ENDIF
 
@@ -678,5 +702,5 @@
     w  => w_1;   w_p  => w_2;   tw_m  => w_3
 
-    IF ( humidity  .OR.  passive_scalar )  THEN
+    IF ( humidity )  THEN
        q => q_1;  q_p => q_2;  tq_m => q_3
        IF ( humidity )  THEN
@@ -696,4 +720,8 @@
        ENDIF
     ENDIF
+    
+    IF ( passive_scalar )  THEN
+       s => s_1;  s_p => s_2;  ts_m => s_3
+    ENDIF    
 
     IF ( ocean )  THEN
@@ -773,5 +801,5 @@
           ENDDO
 
-          IF ( humidity  .OR.  passive_scalar )  THEN
+          IF ( humidity )  THEN
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
@@ -788,4 +816,11 @@
 
              ENDIF
+          ENDIF
+          IF ( passive_scalar )  THEN
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   s(:,j,i) = s_init
+                ENDDO
+             ENDDO   
           ENDIF
 
@@ -830,5 +865,5 @@
 !--       This could actually be computed more accurately in the 1D model.
 !--       Update when opportunity arises!
-          IF ( humidity  .OR.  passive_scalar )  THEN
+          IF ( humidity )  THEN
              qs = 0.0_wp
              IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
@@ -837,4 +872,7 @@
              ENDIF
           ENDIF
+!
+!--       Initialize scaling parameter for passive scalar
+          IF ( passive_scalar ) ss = 0.0_wp          
 
 !
@@ -881,5 +919,5 @@
              u_init  = unudge(:,1)
              v_init  = vnudge(:,1)
-             IF ( humidity  .OR.  passive_scalar )  THEN
+             IF ( humidity  )  THEN ! is passive_scalar correct???
                 q_init = qnudge(:,1)
              ENDIF
@@ -915,5 +953,5 @@
           ENDIF
 
-          IF ( humidity  .OR.  passive_scalar )  THEN
+          IF ( humidity )  THEN
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
@@ -931,4 +969,12 @@
 
              ENDIF
+          ENDIF
+          
+          IF ( passive_scalar )  THEN
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   s(:,j,i) = s_init
+                ENDDO
+             ENDDO
           ENDIF
 
@@ -975,5 +1021,6 @@
           vsws  = 0.0_wp
           vswst = top_momentumflux_v
-          IF ( humidity  .OR.  passive_scalar ) qs = 0.0_wp
+          IF ( humidity )       qs = 0.0_wp
+          IF ( passive_scalar ) ss = 0.0_wp
 
 !
@@ -1015,5 +1062,5 @@
 !
 !--    Calculate virtual potential temperature
-       IF ( humidity ) vpt = pt * ( 1.0_wp + 0.61_wp * q )
+       IF ( humidity )  vpt = pt * ( 1.0_wp + 0.61_wp * q )
 
 !
@@ -1053,5 +1100,5 @@
 !
 !--       Store initial scalar profile
-          hom(:,1,26,:) = SPREAD(  q(:,nys,nxl), 2, statistic_regions+1 )
+          hom(:,1,115,:) = SPREAD(  s(:,nys,nxl), 2, statistic_regions+1 )
        ENDIF
 
@@ -1116,5 +1163,5 @@
 !
 !--       Determine the near-surface water flux
-          IF ( humidity  .OR.  passive_scalar )  THEN
+          IF ( humidity )  THEN
              IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
                 qrsws = 0.0_wp
@@ -1138,4 +1185,22 @@
              ENDIF
           ENDIF
+!
+!--       Initialize the near-surface scalar flux
+          IF ( passive_scalar )  THEN
+             IF ( constant_scalarflux )  THEN
+                ssws   = surface_scalarflux
+!
+!--             Over topography surface_scalarflux is replaced by 
+!--             wall_scalarflux(0)
+                IF ( TRIM( topography ) /= 'flat' )  THEN
+                   wall_sflux = wall_scalarflux
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         IF ( nzb_s_inner(j,i) /= 0 )  ssws(j,i) = wall_sflux(0)
+                      ENDDO
+                   ENDDO
+                ENDIF
+             ENDIF
+          ENDIF          
 
        ENDIF
@@ -1152,5 +1217,5 @@
              tswst = top_heatflux
 
-             IF ( humidity  .OR.  passive_scalar )  THEN
+             IF ( humidity )  THEN
                 qswst = 0.0_wp
                 IF ( cloud_physics  .AND.  microphysics_seifert ) THEN
@@ -1159,4 +1224,5 @@
                 ENDIF
              ENDIF
+             IF ( passive_scalar )  sswst = 0.0_wp
 
              IF ( ocean )  THEN
@@ -1192,5 +1258,5 @@
           ENDIF
 
-          IF ( humidity  .OR.  passive_scalar )  THEN
+          IF ( humidity  )  THEN
              IF (  .NOT.  constant_waterflux )  qsws   = 0.0_wp
              IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
@@ -1199,4 +1265,5 @@
              ENDIF
           ENDIF
+          IF ( passive_scalar  .AND.  .NOT.  constant_scalarflux )  ssws = 0.0_wp
 
        ENDIF
@@ -1261,8 +1328,10 @@
 !--    If required, change the surface humidity/scalar at the start of the 3D
 !--    run
-       IF ( ( humidity .OR. passive_scalar ) .AND.                             &
-            q_surface_initial_change /= 0.0_wp )  THEN
+       IF ( humidity  .AND.  q_surface_initial_change /= 0.0_wp )              &
           q(nzb,:,:) = q(nzb,:,:) + q_surface_initial_change
-       ENDIF
+          
+       IF ( passive_scalar .AND.  s_surface_initial_change /= 0.0_wp )         &
+          s(nzb,:,:) = s(nzb,:,:) + s_surface_initial_change
+        
 
 !
@@ -1271,5 +1340,5 @@
        e_p = e; pt_p = pt; u_p = u; v_p = v; w_p = w
 
-       IF ( humidity  .OR.  passive_scalar )  THEN
+       IF ( humidity  )  THEN
           tq_m = 0.0_wp
           q_p = q
@@ -1281,4 +1350,9 @@
           ENDIF
        ENDIF
+       
+       IF ( passive_scalar )  THEN
+          ts_m = 0.0_wp
+          s_p  = s
+       ENDIF       
 
        IF ( ocean )  THEN
@@ -1323,6 +1397,4 @@
 #endif
        ENDDO
-       write(9,*) "EOF read binary"
-       flush(9)
 
 !
@@ -1335,5 +1407,5 @@
 !--       profiles from the prerun. Alternatively, prescribed profiles
 !--       for u,v-components can be used.
-          ALLOCATE( mean_inflow_profiles(nzb:nzt+1,6) )
+          ALLOCATE( mean_inflow_profiles(nzb:nzt+1,7) )
 
           IF ( use_prescribed_profile_data )  THEN
@@ -1346,5 +1418,8 @@
           mean_inflow_profiles(:,4) = hom_sum(:,4,0)       ! pt
           mean_inflow_profiles(:,5) = hom_sum(:,8,0)       ! e
-          mean_inflow_profiles(:,6) = hom_sum(:,41,0)      ! q
+          IF ( humidity )                                                      &
+             mean_inflow_profiles(:,6) = hom_sum(:,41,0)   ! q
+          IF ( passive_scalar )                                                &
+             mean_inflow_profiles(:,7) = hom_sum(:,115,0)   ! s
 
 !
@@ -1373,6 +1448,8 @@
                    pt(k,j,nxlg:-1) = mean_inflow_profiles(k,4)
                    e(k,j,nxlg:-1)  = mean_inflow_profiles(k,5)
-                   IF ( humidity  .OR.  passive_scalar )                       &
+                   IF ( humidity )                                             &
                       q(k,j,nxlg:-1)  = mean_inflow_profiles(k,6)
+                   IF ( passive_scalar )                                       &
+                      s(k,j,nxlg:-1)  = mean_inflow_profiles(k,7)                      
                 ENDDO
              ENDDO
@@ -1459,5 +1536,5 @@
 !--    including ghost points)
        e_p = e; pt_p = pt; u_p = u; v_p = v; w_p = w
-       IF ( humidity  .OR.  passive_scalar )  THEN
+       IF ( humidity )  THEN
           q_p = q
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
@@ -1466,5 +1543,6 @@
           ENDIF
        ENDIF
-       IF ( ocean )  sa_p = sa
+       IF ( passive_scalar )  s_p  = s
+       IF ( ocean          )  sa_p = sa
 
 !
@@ -1473,5 +1551,5 @@
 !--    there before they are set. 
        te_m = 0.0_wp; tpt_m = 0.0_wp; tu_m = 0.0_wp; tv_m = 0.0_wp; tw_m = 0.0_wp
-       IF ( humidity  .OR.  passive_scalar )  THEN
+       IF ( humidity )  THEN
           tq_m = 0.0_wp
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
@@ -1480,5 +1558,6 @@
           ENDIF
        ENDIF
-       IF ( ocean )  tsa_m = 0.0_wp
+       IF ( passive_scalar )  ts_m  = 0.0_wp
+       IF ( ocean          )  tsa_m = 0.0_wp
 
        CALL location_message( 'finished', .TRUE. )
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 1959)
+++ palm/trunk/SOURCE/modules.f90	(revision 1960)
@@ -19,5 +19,14 @@
 ! Current revisions:
 ! ------------------
-! 
+! Separate humidity and passive scalar
+! +bc_s_t_val, diss_s_s, diss_l_s, flux_s_s, flux_l_s, s, sp, s1, s2, s3, ssws_av, 
+!  s_init, s_surf, sums_wsss_ws_l, ss, ssws, sswst, ts_m, wall_sflux
+! +constant_scalarflux, ibc_s_b, ibc_s_t, s_vertical_gradient_level_ind
+!
+! Unused variables removed
+! -gamma_x, gamma_y, gamma_z, var_x, var_y, var_z
+!
+! Change default values (in order to unify gradient calculation): 
+! pt_vertical_gradient_level, sa_vertical_gradient_level
 !
 ! Former revisions:
@@ -411,18 +420,19 @@
           dd2zu, dzu, ddzw, dzw, hyp, inflow_damping_factor, l_grid,           &
           ptdf_x, ptdf_y, p_surf, pt_surf, pt_init, qsws_surf, q_init, q_surf, &
-          rdf, rdf_sc, ref_state, sa_init, shf_surf, timenudge, time_surf,     &
-          time_vert, tmp_tnudge, ug, u_init, u_nzb_p1_for_vfc, vg, v_init,     &
-          v_nzb_p1_for_vfc, w_subs, zu, zw
+          rdf, rdf_sc, ref_state, s_init, s_surf, sa_init, shf_surf,           &
+          timenudge, time_surf, time_vert, tmp_tnudge, ug, u_init,             &
+          u_nzb_p1_for_vfc, vg, v_init, v_nzb_p1_for_vfc, w_subs, zu, zw
 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::                                   &
           c_u, c_v, c_w, diss_s_e, diss_s_nr, diss_s_pt, diss_s_q,             &
-          diss_s_qr, diss_s_sa, diss_s_u, diss_s_v, diss_s_w, dzu_mg, dzw_mg,  &
-          flux_s_e, flux_s_nr, flux_s_pt, flux_s_q, flux_s_qr, flux_s_sa,      &
-          flux_s_u, flux_s_v, flux_s_w, f1_mg, f2_mg, f3_mg,                   &
-          mean_inflow_profiles, nrs, nrsws, nrswst,                            &
+          diss_s_qr, diss_s_s, diss_s_sa, diss_s_u, diss_s_v, diss_s_w, dzu_mg,&
+          dzw_mg, flux_s_e, flux_s_nr, flux_s_pt, flux_s_q, flux_s_qr,         &
+          flux_s_s, flux_s_sa, flux_s_u, flux_s_v, flux_s_w, f1_mg, f2_mg,     &
+          f3_mg, mean_inflow_profiles, nrs, nrsws, nrswst,                     &
           ol,                                                                  & !< Obukhov length
           precipitation_amount, precipitation_rate, ptnudge, pt_slope_ref,     &
           qnudge, qs, qsws, qswst, qswst_remote, qrs, qrsws, qrswst,           &
-          saswsb, saswst, shf, tnudge, td_lsa_lpt, td_lsa_q, td_sub_lpt,       &
+          saswsb, saswst, shf, ss, ssws, sswst, tnudge, td_lsa_lpt, td_lsa_q,  &
+          td_sub_lpt,                                                          &
           td_sub_q, total_2d_a, total_2d_o, ts, tswst, ug_vert, unudge, us,    &
           usws, uswst, vnudge, vg_vert, vsws, vswst, wnudge, wsubs_vert,       &
@@ -433,8 +443,8 @@
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::                                 &
           d, de_dx, de_dy, de_dz, diss, diss_l_e,                              &
-          diss_l_nr, diss_l_pt, diss_l_q, diss_l_qr, diss_l_sa, diss_l_u,      &
-          diss_l_v, diss_l_w, flux_l_e, flux_l_nr, flux_l_pt, flux_l_q,        &
-          flux_l_qr, flux_l_sa, flux_l_u, flux_l_v, flux_l_w, kh, km,          &
-          l_wall, prr, p_loc, tend, tric,                                      &
+          diss_l_nr, diss_l_pt, diss_l_q, diss_l_qr, diss_l_s, diss_l_sa,      &
+          diss_l_u, diss_l_v, diss_l_w, flux_l_e, flux_l_nr, flux_l_pt,        &
+          flux_l_q, flux_l_qr, flux_l_s, flux_l_sa, flux_l_u, flux_l_v,        &
+          flux_l_w, kh, km, l_wall, prr, p_loc, tend, tric,                    &
           u_m_l, u_m_n, u_m_r, u_m_s, v_m_l, v_m_n, v_m_r, v_m_s, w_m_l,       &
           w_m_n, w_m_r, w_m_s
@@ -443,22 +453,20 @@
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                         &
           e, e_p, nr, nr_p, p, prho, pt, pt_p, q, q_p, qc, ql, ql_c, ql_v,     &
-          ql_vp, qr, qr_p, rho, sa, sa_p, te_m, tnr_m, tpt_m, tq_m, tqr_m,     &
-          tsa_m, tu_m, tv_m, tw_m, u, u_p, v, v_p, vpt, w, w_p
+          ql_vp, qr, qr_p, rho, s, s_p, sa, sa_p, te_m, tnr_m, tpt_m, tq_m,    &
+          tqr_m, ts_m, tsa_m, tu_m, tv_m, tw_m, u, u_p, v, v_p, vpt, w, w_p
 #else
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                         &
           e_1, e_2, e_3, p, prho_1, nr_1, nr_2, nr_3, pt_1, pt_2, pt_3, q_1,   &
           q_2, q_3, qc_1, ql_v, ql_vp, ql_1, ql_2, qr_1, qr_2, qr_3, rho_1,    &
-          sa_1, sa_2, sa_3, u_1, u_2, u_3, v_1, v_2, v_3, vpt_1, w_1, w_2, w_3
+          s_1, s_2, s_3, sa_1, sa_2, sa_3, u_1, u_2, u_3, v_1, v_2, v_3, vpt_1,&
+          w_1, w_2, w_3
 
     REAL(wp), DIMENSION(:,:,:), POINTER ::                                     &
           e, e_p, nr, nr_p, prho, pt, pt_p, q, q_p, qc, ql, ql_c, qr, qr_p,    &
-          rho, sa, sa_p, te_m, tnr_m, tpt_m, tq_m, tqr_m, tsa_m, tu_m, tv_m,   &
-          tw_m, u, u_p, v, v_p, vpt, w, w_p
+          rho, s, s_p, sa, sa_p, te_m, tnr_m, tpt_m, tq_m, tqr_m, ts_m,        &
+          tsa_m, tu_m, tv_m, tw_m, u, u_p, v, v_p, vpt, w, w_p
 #endif
 
     REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  rif_wall, tri
-
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: var_x, var_y, var_z, gamma_x,   &
-                                           gamma_y, gamma_z
 
 
@@ -481,4 +489,5 @@
                                               ol_av,                 & !< Avg. of Obukhov length
                                               qsws_av,               & !< Avg. of surface moisture flux
+                                              ssws_av,               & !< Avg. of surface scalar flux
                                               shf_av,                & !< Avg. of surface heat flux
                                               ts_av,                 & !< Avg. of characteristic temperature scale
@@ -631,5 +640,5 @@
                      dz_stretch_level_index, ensemble_member_nr = 0, gamma_mg, gathered_size, &
                      grid_level, ibc_e_b, ibc_p_b, ibc_p_t, &
-                     ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, &
+                     ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, ibc_s_b, ibc_s_t, &
                      ibc_sa_t, ibc_uv_b, ibc_uv_t, &
                      inflow_disturbance_begin = -1, inflow_disturbance_end = -1, &
@@ -657,4 +666,5 @@
                      pt_vertical_gradient_level_ind(10) = -9999, &
                      q_vertical_gradient_level_ind(10) = -9999, &
+                     s_vertical_gradient_level_ind(10) = -9999, &                     
                      sa_vertical_gradient_level_ind(10) = -9999, &
                      section(100,3), section_xy(100) = -9999, &
@@ -685,4 +695,5 @@
                 constant_top_momentumflux = .FALSE., &
                 constant_top_salinityflux = .TRUE., &
+                constant_scalarflux = .TRUE., &              
                 constant_waterflux = .TRUE., create_disturbances = .TRUE., &
                 data_output_2d_on_each_pe = .TRUE., & 
@@ -739,5 +750,5 @@
                  alpha_surface = 0.0_wp, atmos_ocean_sign = 1.0_wp, &
                  averaging_interval = 0.0_wp, averaging_interval_pr = 9999999.9_wp, &
-                 bc_pt_t_val, bc_q_t_val, bottom_salinityflux = 0.0_wp, &
+                 bc_pt_t_val, bc_q_t_val, bc_s_t_val, bottom_salinityflux = 0.0_wp, &
                  building_height = 50.0_wp, building_length_x = 50.0_wp, &
                  building_length_y = 50.0_wp, building_wall_left = 9999999.9_wp, &
@@ -813,5 +824,5 @@
                  mask_scale(3), &
                  pt_vertical_gradient(10) = 0.0_wp, &
-                 pt_vertical_gradient_level(10) = -9999999.9_wp, &
+                 pt_vertical_gradient_level(10) = -1.0_wp, &
                  q_vertical_gradient(10) = 0.0_wp, &
                  q_vertical_gradient_level(10) = -1.0_wp, &
@@ -819,5 +830,5 @@
                  s_vertical_gradient_level(10) = -1.0_wp, &
                  sa_vertical_gradient(10) = 0.0_wp, &
-                 sa_vertical_gradient_level(10) = -9999999.9_wp, &
+                 sa_vertical_gradient_level(10) = -1.0_wp, &
                  skip_time_domask(max_masks) = 9999999.9_wp, threshold(20) = 0.0_wp, &
                  time_domask(max_masks) = 0.0_wp, &
@@ -833,5 +844,5 @@
                  wall_humidityflux(0:4) = 0.0_wp, wall_nrflux(0:4) = 0.0_wp, &
                  wall_qflux(0:4) = 0.0_wp, wall_qrflux(0:4) = 0.0_wp, &
-                 wall_salinityflux(0:4) = 0.0_wp, wall_scalarflux(0:4) = 0.0_wp, &
+                 wall_salinityflux(0:4) = 0.0_wp, wall_sflux(0:4) = 0.0_wp, wall_scalarflux(0:4) = 0.0_wp, &
                  subs_vertical_gradient(10) = 0.0_wp, &
                  subs_vertical_gradient_level(10) = -9999999.9_wp
@@ -1255,7 +1266,8 @@
                                                   sums_wsnrs_ws_l,                &
                                                   sums_wspts_ws_l,                &
+                                                  sums_wsqs_ws_l,                 &   
+                                                  sums_wsqrs_ws_l,                &
                                                   sums_wssas_ws_l,                &
-                                                  sums_wsqs_ws_l,                 &
-                                                  sums_wsqrs_ws_l,                &
+                                                  sums_wsss_ws_l,                 &
                                                   sums_ls_l
                                               
Index: palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 1959)
+++ palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 1960)
@@ -19,5 +19,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Additional labels and units for timeseries output of passive scalar-related 
+! quantities
 ! 
 ! Former revisions:
@@ -174,7 +175,7 @@
              'm2/s2  ', 'm2/s2  ', 'm2/s2  ', 'm2/s2  ', 'number2' /)
 
-    INTEGER(iwp) ::  dots_num  = 31  !< number of timeseries defined by default
-    INTEGER(iwp) ::  dots_soil = 24  !< starting index for soil-timeseries
-    INTEGER(iwp) ::  dots_rad  = 32  !< starting index for radiation-timeseries
+    INTEGER(iwp) ::  dots_num  = 33  !< number of timeseries defined by default
+    INTEGER(iwp) ::  dots_soil = 26  !< starting index for soil-timeseries
+    INTEGER(iwp) ::  dots_rad  = 34  !< starting index for radiation-timeseries
 
     CHARACTER (LEN=13), DIMENSION(dots_max) :: dots_label =                    &
@@ -186,12 +187,12 @@
              'wpt          ', 'pt(0)        ', 'pt(z_mo)     ',                &
              'w"u"0        ', 'w"v"0        ', 'w"q"0        ',                &
-             'ol           ', 'q*           ', 'ghf_eb       ',                &
-             'shf_eb       ', 'qsws_eb      ', 'qsws_liq_eb  ',                &
-             'qsws_soil_eb ', 'qsws_veg_eb  ', 'r_a          ',                &
-             'r_s          ', 'rad_net      ', 'rad_lw_in    ',                &
-             'rad_lw_out   ', 'rad_sw_in    ', 'rad_sw_out   ',                &
-             'rrtm_aldif   ', 'rrtm_aldir   ', 'rrtm_asdif   ',                &
-             'rrtm_asdir   ',                                                  &
-             ( 'unknown      ', i9 = 1, dots_max-40 ) /)
+             'ol           ', 'q*           ', 'w"s"         ',                &
+             's*           ', 'ghf_eb       ', 'shf_eb       ',                &
+             'qsws_eb      ', 'qsws_liq_eb  ', 'qsws_soil_eb ',                &
+             'qsws_veg_eb  ', 'r_a          ', 'r_s          ',                &
+             'rad_net      ', 'rad_lw_in    ', 'rad_lw_out   ',                &
+             'rad_sw_in    ', 'rad_sw_out   ', 'rrtm_aldif   ',                &
+             'rrtm_aldir   ', 'rrtm_asdif   ', 'rrtm_asdir   ',                &                                               
+             ( 'unknown      ', i9 = 1, dots_max-42 ) /)
 
     CHARACTER (LEN=13), DIMENSION(dots_max) :: dots_unit =                     &
@@ -203,12 +204,12 @@
              'K m/s        ', 'K            ', 'K            ',                &
              'm2/s2        ', 'm2/s2        ', 'kg m/s       ',                &
-             'm            ', 'kg/kg        ', '             ',                &
+             'm            ', 'kg/kg        ', 'kg m/(kg s)  ',                &
+             'kg/kg        ', '             ', '             ',                &
              '             ', '             ', '             ',                &
-             '             ', 'W/m2         ', 's/m          ',                &
-             '             ', 'W/m2         ', 'W/m2         ',                &
+             'W/m2         ', 's/m          ', '             ',                &
              'W/m2         ', 'W/m2         ', 'W/m2         ',                &
+             'W/m2         ', 'W/m2         ', '             ',                &
              '             ', '             ', '             ',                &
-             '             ',                                                  &
-             ( 'unknown      ', i9 = 1, dots_max-40 ) /)
+             ( 'unknown      ', i9 = 1, dots_max-42 ) /)
 
     CHARACTER (LEN=9), DIMENSION(300) ::  dopr_unit = 'unknown'
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 1959)
+++ palm/trunk/SOURCE/palm.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Separate humidity and passive scalar
 ! 
 ! Former revisions:
@@ -361,7 +361,6 @@
           ENDIF
           IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e, nbgp )
-          IF (humidity  .OR.  passive_scalar)  THEN
-             CALL exchange_horiz( q, nbgp )
-          ENDIF
+          IF ( humidity       )  CALL exchange_horiz( q, nbgp )
+          IF ( passive_scalar )  CALL exchange_horiz( s, nbgp )
        ENDIF
 
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 1959)
+++ palm/trunk/SOURCE/parin.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Allocation of s_init
 ! 
 ! Former revisions:
@@ -218,5 +218,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  pt_init, q_init, ref_state, sa_init, ug, u_init, v_init,        &
+        ONLY:  pt_init, q_init, ref_state, s_init, sa_init, ug, u_init, v_init,&
                vg
 
@@ -597,5 +597,5 @@
 !--          ATTENTION: in case of changes to the following statement please
 !--                  also check the allocate statement in routine read_var_list
-             ALLOCATE( pt_init(0:nz+1), q_init(0:nz+1),                       &
+             ALLOCATE( pt_init(0:nz+1), q_init(0:nz+1), s_init(0:nz+1),        &
                        ref_state(0:nz+1), sa_init(0:nz+1), ug(0:nz+1),         &
                        u_init(0:nz+1), v_init(0:nz+1), vg(0:nz+1),             &
Index: palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 1959)
+++ palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Separate humidity and passive scalar
 ! 
 ! Former revisions:
@@ -86,5 +86,5 @@
  
     USE arrays_3d,                                                             &
-        ONLY:  dzu, dzw, e, q, shf, tend, u, v, w, zu, zw 
+        ONLY:  dzu, dzw, e, q, s, shf, tend, u, v, w, zu, zw 
 
     USE indices,                                                               &
@@ -818,5 +818,5 @@
 
 !
-!--       scalar concentration
+!--       humidity
           CASE ( 5 )
              DO  i = nxl, nxr
@@ -866,4 +866,29 @@
                 ENDDO
              ENDDO 
+!
+!--       scalar concentration
+          CASE ( 7 )
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_s_inner(j,i)+1, nzb_s_inner(j,i)+pch_index
+                      kk = k - nzb_s_inner(j,i)  !- lad arrays are defined flat
+                      tend(k,j,i) = tend(k,j,i) -                              &
+                                       lsec *                                  &
+                                       lad_s(kk,j,i) *                         &
+                                       SQRT( ( 0.5_wp * ( u(k,j,i) +           &
+                                                          u(k,j,i+1) )         &
+                                             )**2 +                            &
+                                             ( 0.5_wp * ( v(k,j,i) +           &
+                                                          v(k,j+1,i) )         &
+                                             )**2 +                            &
+                                             ( 0.5_wp * ( w(k-1,j,i) +         & 
+                                                          w(k,j,i) )           &
+                                             )**2                              &
+                                           ) *                                 &
+                                       ( s(k,j,i) - lsc )
+                   ENDDO
+                ENDDO
+             ENDDO    
+
 
 
@@ -1146,5 +1171,5 @@
 
 !
-!--       scalar concentration 
+!--       humidity
           CASE ( 5 )
              DO  k = nzb_s_inner(j,i)+1, nzb_s_inner(j,i)+pch_index
@@ -1186,4 +1211,25 @@
                                  e(k,j,i)
              ENDDO
+             
+!
+!--       scalar concentration 
+          CASE ( 7 )
+             DO  k = nzb_s_inner(j,i)+1, nzb_s_inner(j,i)+pch_index
+                kk = k - nzb_s_inner(j,i)  !- lad arrays are defined flat
+                tend(k,j,i) = tend(k,j,i) -                                    &
+                                 lsec *                                        &
+                                 lad_s(kk,j,i) *                               &
+                                 SQRT( ( 0.5_wp * ( u(k,j,i) +                 &
+                                                    u(k,j,i+1) )               &
+                                       )**2  +                                 &
+                                       ( 0.5_wp * ( v(k,j,i) +                 &
+                                                    v(k,j+1,i) )               &
+                                       )**2 +                                  &
+                                       ( 0.5_wp * ( w(k-1,j,i) +               &
+                                                    w(k,j,i) )                 &
+                                       )**2                                    &
+                                     ) *                                       &
+                                 ( s(k,j,i) - lsc )
+             ENDDO                
 
        CASE DEFAULT
